## liburing 0.7

=== test/Makefile ===
prefix ?= /usr
datadir ?= $(prefix)/share

INSTALL=install

CFLAGS ?= -g -O2
XCFLAGS =
override CFLAGS += -Wall -Wextra -Wno-unused-parameter -Wno-sign-compare\
	-D_GNU_SOURCE -D__SANE_USERSPACE_TYPES__ -L../src/ \
	-I../src/include/ -include ../config-host.h
CXXFLAGS += $(CFLAGS) -std=c++11

all_targets += poll poll-cancel ring-leak fsync io_uring_setup io_uring_register \
	       io_uring_enter nop sq-full cq-full 35fa71a030ca-test \
		917257daa0fe-test b19062a56726-test eeed8b54e0df-test link \
		send_recvmsg a4c0b3decb33-test 500f9fbadef8-test timeout \
		sq-space_left stdout cq-ready cq-peek-batch file-register \
		cq-size 8a9973408177-test a0908ae19763-test 232c93d07b74-test \
		socket-rw accept timeout-overflow defer read-write io-cancel \
		link-timeout cq-overflow link_drain fc2a85cb02ef-test \
		poll-link accept-link fixed-link poll-cancel-ton teardowns \
		poll-many b5837bd5311d-test accept-test d77a67ed5f27-test \
		connect 7ad0e4b2f83c-test submit-reuse fallocate open-close \
		file-update accept-reuse poll-v-poll fadvise madvise \
		short-read openat2 probe shared-wq personality eventfd \
		send_recv eventfd-ring across-fork sq-poll-kthread splice \
		lfs-openat lfs-openat-write iopoll d4ae271dfaae-test \
		eventfd-disable close-opath ce593a6c480a-test cq-overflow-peek

include ../Makefile.quiet

ifneq ($(MAKECMDGOALS),clean)
include ../config-host.mak
endif

ifdef CONFIG_HAVE_STATX
all_targets += statx
endif

ifdef CONFIG_HAVE_CXX
all_targets += sq-full-cpp
endif

all: $(all_targets)

%: %.c
	$(QUIET_CC)$(CC) $(CFLAGS) -o $@ $< -luring $(XCFLAGS)

%: %.cc
	$(QUIET_CC)$(CXX) $(CXXFLAGS) -o $@ $< -luring $(XCFLAGS)

test_srcs := poll.c poll-cancel.c ring-leak.c fsync.c io_uring_setup.c \
	io_uring_register.c io_uring_enter.c nop.c sq-full.c cq-full.c \
	35fa71a030ca-test.c 917257daa0fe-test.c b19062a56726-test.c \
	eeed8b54e0df-test.c link.c send_recvmsg.c a4c0b3decb33-test.c \
	500f9fbadef8-test.c timeout.c sq-space_left.c stdout.c cq-ready.c\
	cq-peek-batch.c file-register.c cq-size.c 8a9973408177-test.c \
	a0908ae19763-test.c 232c93d07b74-test.c socket-rw.c accept.c \
	timeout-overflow.c defer.c read-write.c io-cancel.c link-timeout.c \
	cq-overflow.c link_drain.c fc2a85cb02ef-test.c poll-link.c \
	accept-link.c fixed-link.c poll-cancel-ton.c teardowns.c poll-many.c \
	b5837bd5311d-test.c accept-test.c d77a67ed5f27-test.c connect.c \
	7ad0e4b2f83c-test.c submit-reuse.c fallocate.c open-close.c \
	file-update.c accept-reuse.c poll-v-poll.c fadvise.c \
	madvise.c short-read.c openat2.c probe.c shared-wq.c \
	personality.c eventfd.c eventfd-ring.c across-fork.c sq-poll-kthread.c \
	splice.c lfs-openat.c lfs-openat-write.c iopoll.c d4ae271dfaae-test.c \
	eventfd-disable.c close-opath.c ce593a6c480a-test.c cq-overflow-peek.c

ifdef CONFIG_HAVE_STATX
test_srcs += statx.c
endif

ifdef CONFIG_HAVE_CXX
test_srcs += sq-full-cpp
endif

test_objs := $(patsubst %.c,%.ol,$(test_srcs))

35fa71a030ca-test: XCFLAGS = -lpthread
232c93d07b74-test: XCFLAGS = -lpthread
send_recv: XCFLAGS = -lpthread
send_recvmsg: XCFLAGS = -lpthread
poll-link: XCFLAGS = -lpthread
accept-link: XCFLAGS = -lpthread
submit-reuse: XCFLAGS = -lpthread
poll-v-poll: XCFLAGS = -lpthread
across-fork: XCFLAGS = -lpthread
ce593a6c480a-test: XCFLAGS = -lpthread

install: $(all_targets) runtests.sh runtests-loop.sh
	$(INSTALL) -D -d -m 755 $(datadir)/liburing-test/
	$(INSTALL) -D -m 755 $(all_targets) $(datadir)/liburing-test/
	$(INSTALL) -D -m 755 runtests.sh  $(datadir)/liburing-test/
	$(INSTALL) -D -m 755 runtests-loop.sh  $(datadir)/liburing-test/
clean:
	@rm -f $(all_targets) $(test_objs)

runtests: all
	@./runtests.sh $(all_targets)
runtests-loop: all
	@./runtests-loop.sh $(all_targets)

## liburing 0.6

=== debian/changelog ===
liburing (0.6-3ubuntu1) groovy; urgency=medium

  * Fix build and autopkgtest self tests (LP: #1878006).

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Wed, 01 Jul 2020 11:09:38 +0200

liburing (0.6-3) unstable; urgency=medium

  * Add dependencies on libc6-dev | libc-dev and linux-libc-dev (>= 5.1)
    to liburing-dev. (Closes: #959182)
  * Replace mmap patch with upstream one.

 -- Guillem Jover <guillem@debian.org>  Fri, 01 May 2020 05:05:09 +0200

liburing (0.6-2) unstable; urgency=medium

  * Fix build failures on armhf and armel, by using __NR_mmap2 when __NR_mmap
    is not defined, which is fine, because the unit tests pass 0 as offset.

 -- Guillem Jover <guillem@debian.org>  Wed, 22 Apr 2020 01:30:19 +0200

liburing (0.6-1) unstable; urgency=medium

  * Initial release. (Closes: #950903)

 -- Guillem Jover <guillem@debian.org>  Fri, 17 Apr 2020 21:25:25 +0200

=== debian/control ===
Source: liburing
Section: libs
Priority: optional
Maintainer: Guillem Jover <guillem@debian.org>
Vcs-Browser: https://git.hadrons.org/cgit/debian/pkgs/liburing.git
Vcs-Git: https://git.hadrons.org/git/debian/pkgs/liburing.git
Homepage: https://github.com/axboe/liburing
Standards-Version: 4.5.0
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 procps <!nocheck>,

Package: liburing1
Architecture: linux-any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Linux kernel io_uring access library - shared library
 This library provides helpers to setup and teardown io_uring instances,
 and also a simplified interface for applications that do not need (or
 want) to deal with the full kernel side implementation.
 .
 This package contains the shared library.

Package: liburing-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 liburing1 (= ${binary:Version}),
 libc6-dev | libc-dev,
 linux-libc-dev (>= 5.1),
Description: Linux kernel io_uring access library - development files
 This library provides helpers to setup and teardown io_uring instances,
 and also a simplified interface for applications that do not need (or
 want) to deal with the full kernel side implementation.
 .
 This package contains the static library and the header files.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export DEB_CFLAGS_MAINT_PREPEND = -Wall

DPKG_EXPORT_BUILDTOOLS = 1
include /usr/share/dpkg/buildtools.mk

buildflags =
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	buildflags += V=1
endif

%:
	dh $@

override_dh_auto_configure:
	./configure \
	  --prefix=/usr \
	  --includedir=/usr/include \
	  --datadir=/usr/share \
	  --mandir=/usr/share/man \
	  --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	  --libdevdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	  --cc=$(CC)

override_dh_auto_build:
	dh_auto_build -- $(buildflags)

# XXX: The tests do not pass yet on Linux 5.5, and they are not being
# skipped either.
override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
 ifeq ($(DEB_RULES_REQUIRES_ROOT),dpkg/target-subcommand)
  ifeq (,$(findstring fakeroot,$(DEB_GAIN_ROOT_CMD)))
	$(DEB_GAIN_ROOT_CMD) dh_auto_test -- runtests || true
  else
	@echo 'Warning: Tests require real root, not fakeroot.  Skipping.' >&2
  endif
 else ifeq (0,$(shell id -u))
	dh_auto_test -- runtests
 else
	@echo 'Warning: Tests require root.  Skipping.' >&2
 endif
endif

## liburing 0.7

=== debian/changelog ===
liburing (0.7-3~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 09 Oct 2021 10:22:24 -0700

liburing (0.7-3~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports (no source/packaging changes).

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 29 Dec 2020 16:29:13 +0300

liburing (0.7-3) unstable; urgency=medium

  * Switch to Standards-Version 4.5.1 (no changes needed).
  * Add new debian/upstream/metadata file.

 -- Guillem Jover <guillem@debian.org>  Thu, 24 Dec 2020 18:11:40 +0100

liburing (0.7-2) unstable; urgency=medium

  * Bump the minimum version for all symbols in the symbols file, to
    workaround that 0.7 upstream version unintentionally broke the ABI
    without bumping the SONAME. (Closes: #972758)

 -- Guillem Jover <guillem@debian.org>  Wed, 28 Oct 2020 10:35:07 +0100

liburing (0.7-1) unstable; urgency=medium

  * New upstream version.
  * Refactor debian/tests/test-build into two loops to avoid repetition.
  * Use link-cp instead of io_uring-cp as example command to test.
    Reported by Christian Ehrhardt <christian.ehrhardt@canonical.com>.

 -- Guillem Jover <guillem@debian.org>  Wed, 09 Sep 2020 04:26:54 +0200

=== debian/control ===
Source: liburing
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Guillem Jover <guillem@debian.org>
Uploaders: Michael Tokarev <mjt@tls.msk.ru>
Vcs-Browser: https://git.hadrons.org/cgit/debian/pkgs/liburing.git
Vcs-Git: https://git.hadrons.org/git/debian/pkgs/liburing.git
Homepage: https://github.com/axboe/liburing
Standards-Version: 4.5.1
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 12), procps <!nocheck>

Package: liburing1
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Linux kernel io_uring access library - shared library
 This library provides helpers to setup and teardown io_uring instances,
 and also a simplified interface for applications that do not need (or
 want) to deal with the full kernel side implementation.
 .
 This package contains the shared library.

Package: liburing-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: libc6-dev | libc-dev,
         liburing1 (= ${binary:Version}),
         linux-libc-dev (>= 5.1),
         ${misc:Depends}
Description: Linux kernel io_uring access library - development files
 This library provides helpers to setup and teardown io_uring instances,
 and also a simplified interface for applications that do not need (or
 want) to deal with the full kernel side implementation.
 .
 This package contains the static library and the header files.

=== debian/rules ===
--- 
+++ 
@@ -33,16 +33,7 @@
 # XXX: The tests do not pass yet on Linux 5.5, and they are not being
 # skipped either.
 override_dh_auto_test:
-ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
- ifeq ($(DEB_RULES_REQUIRES_ROOT),dpkg/target-subcommand)
-  ifeq (,$(findstring fakeroot,$(DEB_GAIN_ROOT_CMD)))
-	$(DEB_GAIN_ROOT_CMD) dh_auto_test -- runtests || true
-  else
-	@echo 'Warning: Tests require real root, not fakeroot.  Skipping.' >&2
-  endif
- else ifeq (0,$(shell id -u))
-	dh_auto_test -- runtests
- else
-	@echo 'Warning: Tests require root.  Skipping.' >&2
- endif
-endif
+	dh_auto_test -- runtests || true
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym

=== debian/tests/control ===
Tests: test-build
Restrictions: flaky skippable
Depends: build-essential, liburing-dev, pkg-config

Tests: test-unit
Restrictions: flaky rw-build-tree
Depends: build-essential

## liburing 2.0

=== debian/changelog ===
liburing (2.0-1) experimental; urgency=medium

  * New upstream version.
    - Bump shared library SONAME to liburing2.
    - Install man pages from section 3 and 7.
  * Add patch to skip tests that require root.

 -- Guillem Jover <guillem@debian.org>  Thu, 09 Sep 2021 03:29:04 +0200

=== debian/control ===
Source: liburing
Section: libs
Priority: optional
Maintainer: Guillem Jover <guillem@debian.org>
Vcs-Browser: https://git.hadrons.org/cgit/debian/pkgs/liburing.git
Vcs-Git: https://git.hadrons.org/git/debian/pkgs/liburing.git
Homepage: https://github.com/axboe/liburing
Standards-Version: 4.5.1
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 procps <!nocheck>,

Package: liburing2
Architecture: linux-any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Linux kernel io_uring access library - shared library
 This library provides helpers to setup and teardown io_uring instances,
 and also a simplified interface for applications that do not need (or
 want) to deal with the full kernel side implementation.
 .
 This package contains the shared library.

Package: liburing-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 liburing2 (= ${binary:Version}),
 libc6-dev | libc-dev,
 linux-libc-dev (>= 5.1),
Description: Linux kernel io_uring access library - development files
 This library provides helpers to setup and teardown io_uring instances,
 and also a simplified interface for applications that do not need (or
 want) to deal with the full kernel side implementation.
 .
 This package contains the static library and the header files.

## liburing 2.1

=== src/Makefile ===
prefix ?= /usr
includedir ?= $(prefix)/include
libdir ?= $(prefix)/lib
libdevdir ?= $(prefix)/lib

CPPFLAGS ?=
override CPPFLAGS += -D_GNU_SOURCE \
	-Iinclude/ -include ../config-host.h
CFLAGS ?= -g -fomit-frame-pointer -O2
override CFLAGS += -D_GNU_SOURCE \
	-Wall -Wextra -Wno-unused-parameter -Wno-sign-compare
SO_CFLAGS=-fPIC $(CFLAGS)
L_CFLAGS=$(CFLAGS)
LINK_FLAGS=
LINK_FLAGS+=$(LDFLAGS)
ENABLE_SHARED ?= 1

soname=liburing.so.2
minor=1
micro=0
libname=$(soname).$(minor).$(micro)
all_targets += liburing.a

ifeq ($(ENABLE_SHARED),1)
all_targets += $(libname)
endif

include ../Makefile.quiet

ifneq ($(MAKECMDGOALS),clean)
include ../config-host.mak
endif

all: $(all_targets)

liburing_srcs := setup.c queue.c syscall.c register.c

liburing_objs := $(patsubst %.c,%.ol,$(liburing_srcs))
liburing_sobjs := $(patsubst %.c,%.os,$(liburing_srcs))

$(liburing_objs) $(liburing_sobjs): include/liburing/io_uring.h

%.os: %.c
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(SO_CFLAGS) -c -o $@ $<

%.ol: %.c
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(L_CFLAGS) -c -o $@ $<

AR ?= ar
RANLIB ?= ranlib
liburing.a: $(liburing_objs)
	@rm -f liburing.a
	$(QUIET_AR)$(AR) r liburing.a $^
	$(QUIET_RANLIB)$(RANLIB) liburing.a

$(libname): $(liburing_sobjs) liburing.map
	$(QUIET_CC)$(CC) $(SO_CFLAGS) -shared -Wl,--version-script=liburing.map -Wl,-soname=$(soname) -o $@ $(liburing_sobjs) $(LINK_FLAGS)

install: $(all_targets)
	install -D -m 644 include/liburing/io_uring.h $(includedir)/liburing/io_uring.h
	install -D -m 644 include/liburing.h $(includedir)/liburing.h
	install -D -m 644 include/liburing/compat.h $(includedir)/liburing/compat.h
	install -D -m 644 include/liburing/barrier.h $(includedir)/liburing/barrier.h
	install -D -m 644 liburing.a $(libdevdir)/liburing.a
ifeq ($(ENABLE_SHARED),1)
	install -D -m 755 $(libname) $(libdir)/$(libname)
	ln -sf $(libname) $(libdir)/$(soname)
	ln -sf $(relativelibdir)$(libname) $(libdevdir)/liburing.so
endif

$(liburing_objs): include/liburing.h

clean:
	@rm -f $(all_targets) $(liburing_objs) $(liburing_sobjs) $(soname).new
	@rm -f *.so* *.a *.o
	@rm -f include/liburing/compat.h

=== debian/changelog ===
liburing (2.1-2build1) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 24 Mar 2022 17:13:48 +0100

liburing (2.1-2) unstable; urgency=medium

  * Upload to unstable.
  * Switch to Standards-Version 4.6.0 (no changes needed).
  * Make globs in debhelper fragment files more specific to avoid them
    missing filename changes or including unintended files.

 -- Guillem Jover <guillem@debian.org>  Sat, 13 Nov 2021 02:07:31 +0100

liburing (2.1-1) experimental; urgency=medium

  * New upstream release.
  * Add patch to fix build failures on any-arm due to direct syscall(2) use.

 -- Guillem Jover <guillem@debian.org>  Thu, 16 Sep 2021 04:02:01 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: liburing
 Section: libs
 Priority: optional
-Maintainer: Guillem Jover <guillem@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Guillem Jover <guillem@debian.org>
 Vcs-Browser: https://git.hadrons.org/cgit/debian/pkgs/liburing.git
 Vcs-Git: https://git.hadrons.org/git/debian/pkgs/liburing.git
 Homepage: https://github.com/axboe/liburing
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),

## liburing 2.1.1

=== debian/changelog ===
liburing (2.1.1-1+dde) UNRELEASED; urgency=medium

  * update

 -- Guillem Jover <guillem@debian.org>  Tue, 26 Jul 2022 11:09:52 +0800

liburing (2.1.1-1+dde) unstable; urgency=medium

  * Add sunway support.

 -- Miao Changwei <miaochangwei@uniontech.com>  Mon, 16 May 2022 01:08:18 +0800

=== debian/rules ===
--- 
+++ 
@@ -30,10 +30,7 @@
 override_dh_auto_build:
 	dh_auto_build -- $(buildflags)
 
-# XXX: The tests do not pass yet on Linux 5.5, and they are not being
+# XXX: The tests do not pass yet on Linux 5.13, and they are not being
 # skipped either.
 override_dh_auto_test:
 	dh_auto_test -- runtests || true
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

## liburing 2.2

=== debian/changelog ===
liburing (2.2-2) unstable; urgency=medium

  * Pass build flags explicitly to dh_auto_build. This will override the
    variables set explicitly by upstream.
  * Add missing License field to test/* stanza in debian/copyright.
  * Documentation cleanup:
    - Fix typos in man pages and test cases.
    - Add missing section numbers to man pages.
    - Lowercase man page title headers.
  * Add missing patch metadata.
  * Enable LFS build options. This should be ABI safe as the shared library
    does not export symbols with problematic type, the only problematic types
    are exposed as part of «static inline» functions from the header file.

 -- Guillem Jover <guillem@debian.org>  Thu, 18 Aug 2022 12:04:48 +0200

liburing (2.2-1) unstable; urgency=medium

  * New upstream release.
    - Remove 0001-test-Use-syscall-wrappers-instead-of-using-syscall-2.patch,
      included upstream.
  * Switch to Standards-Version 4.6.1 (no changes needed).

 -- Guillem Jover <guillem@debian.org>  Fri, 01 Jul 2022 12:38:56 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: liburing
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Guillem Jover <guillem@debian.org>
+Maintainer: Guillem Jover <guillem@debian.org>
 Vcs-Browser: https://git.hadrons.org/cgit/debian/pkgs/liburing.git
 Vcs-Git: https://git.hadrons.org/git/debian/pkgs/liburing.git
 Homepage: https://github.com/axboe/liburing
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
+export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow future=+lfs
 export DEB_CFLAGS_MAINT_PREPEND = -Wall
 
 DPKG_EXPORT_BUILDTOOLS = 1
@@ -13,6 +13,9 @@
 ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
 	buildflags += V=1
 endif
+buildflags += CPPFLAGS="$(CPPFLAGS)"
+buildflags += CFLAGS="$(CFLAGS)"
+buildflags += LDFLAGS="$(LDFLAGS)"
 
 %:
 	dh $@

## liburing 2.3

=== Makefile ===
include Makefile.common

RPMBUILD=$(shell `which rpmbuild >&/dev/null` && echo "rpmbuild" || echo "rpm")

INSTALL=install

default: all

all:
	@$(MAKE) -C src
	@$(MAKE) -C test
	@$(MAKE) -C examples

.PHONY: all install default clean test
.PHONY: FORCE cscope

partcheck: all
	@echo "make partcheck => TODO add tests with out kernel support"

runtests: all
	@$(MAKE) -C test runtests
runtests-loop: all
	@$(MAKE) -C test runtests-loop
runtests-parallel: all
	@$(MAKE) -C test runtests-parallel

config-host.mak: configure
	@if [ ! -e "$@" ]; then					\
	  echo "Running configure ...";				\
	  ./configure;						\
	else							\
	  echo "$@ is out-of-date, running configure";		\
	  sed -n "/.*Configured with/s/[^:]*: //p" "$@" | sh;	\
	fi

ifneq ($(MAKECMDGOALS),clean)
include config-host.mak
endif

%.pc: %.pc.in config-host.mak $(SPECFILE)
	sed -e "s%@prefix@%$(prefix)%g" \
	    -e "s%@libdir@%$(libdir)%g" \
	    -e "s%@includedir@%$(includedir)%g" \
	    -e "s%@NAME@%$(NAME)%g" \
	    -e "s%@VERSION@%$(VERSION)%g" \
	    $< >$@

install: $(NAME).pc
	@$(MAKE) -C src install prefix=$(DESTDIR)$(prefix) \
		includedir=$(DESTDIR)$(includedir) \
		libdir=$(DESTDIR)$(libdir) \
		libdevdir=$(DESTDIR)$(libdevdir) \
		relativelibdir=$(relativelibdir)
	$(INSTALL) -D -m 644 $(NAME).pc $(DESTDIR)$(libdevdir)/pkgconfig/$(NAME).pc
	$(INSTALL) -m 755 -d $(DESTDIR)$(mandir)/man2
	$(INSTALL) -m 644 man/*.2 $(DESTDIR)$(mandir)/man2
	$(INSTALL) -m 755 -d $(DESTDIR)$(mandir)/man3
	$(INSTALL) -m 644 man/*.3 $(DESTDIR)$(mandir)/man3
	$(INSTALL) -m 755 -d $(DESTDIR)$(mandir)/man7
	$(INSTALL) -m 644 man/*.7 $(DESTDIR)$(mandir)/man7

install-tests:
	@$(MAKE) -C test install prefix=$(DESTDIR)$(prefix) datadir=$(DESTDIR)$(datadir)

clean:
	@rm -f config-host.mak config-host.h cscope.out $(NAME).pc test/*.dmesg
	@$(MAKE) -C src clean
	@$(MAKE) -C test clean
	@$(MAKE) -C examples clean

cscope:
	@cscope -b -R

tag-archive:
	@git tag $(TAG)

create-archive:
	@git archive --prefix=$(NAME)-$(VERSION)/ -o $(NAME)-$(VERSION).tar.gz $(TAG)
	@echo "The final archive is ./$(NAME)-$(VERSION).tar.gz."

archive: clean tag-archive create-archive

srpm: create-archive
	$(RPMBUILD) --define "_sourcedir `pwd`" --define "_srcrpmdir `pwd`" --nodeps -bs $(SPECFILE)

=== examples/Makefile ===
CPPFLAGS ?=
override CPPFLAGS += -D_GNU_SOURCE -I../src/include/
CFLAGS ?= -g -O2 -Wall
LDFLAGS ?=
override LDFLAGS += -L../src/ -luring

include ../Makefile.quiet

ifneq ($(MAKECMDGOALS),clean)
include ../config-host.mak
endif

example_srcs := \
	io_uring-cp.c \
	io_uring-test.c \
	io_uring-udp.c \
	link-cp.c \
	poll-bench.c \
	send-zerocopy.c

all_targets :=


ifdef CONFIG_HAVE_UCONTEXT
	example_srcs += ucontext-cp.c
endif
all_targets += ucontext-cp

example_targets := $(patsubst %.c,%,$(patsubst %.cc,%,$(example_srcs)))
all_targets += $(example_targets)


all: $(example_targets)

%: %.c ../src/liburing.a
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $< $(LDFLAGS)

clean:
	@rm -f $(all_targets)

.PHONY: all clean

=== src/Makefile ===
--- 
+++ 
@@ -1,24 +1,26 @@
+include ../Makefile.common
+
 prefix ?= /usr
 includedir ?= $(prefix)/include
 libdir ?= $(prefix)/lib
 libdevdir ?= $(prefix)/lib
 
+LIBURING_CFLAGS ?=
 CPPFLAGS ?=
 override CPPFLAGS += -D_GNU_SOURCE \
 	-Iinclude/ -include ../config-host.h
-CFLAGS ?= -g -fomit-frame-pointer -O2
-override CFLAGS += -D_GNU_SOURCE \
-	-Wall -Wextra -Wno-unused-parameter -Wno-sign-compare
+CFLAGS ?= -g -O3 -Wall -Wextra -fno-stack-protector
+override CFLAGS += -Wno-unused-parameter -Wno-sign-compare \
+	-DLIBURING_INTERNAL \
+	$(LIBURING_CFLAGS)
 SO_CFLAGS=-fPIC $(CFLAGS)
 L_CFLAGS=$(CFLAGS)
 LINK_FLAGS=
 LINK_FLAGS+=$(LDFLAGS)
 ENABLE_SHARED ?= 1
 
-soname=liburing.so.2
-minor=1
-micro=0
-libname=$(soname).$(minor).$(micro)
+soname=liburing.so.$(VERSION_MAJOR)
+libname=liburing.so.$(VERSION)
 all_targets += liburing.a
 
 ifeq ($(ENABLE_SHARED),1)
@@ -33,18 +35,28 @@
 
 all: $(all_targets)
 
-liburing_srcs := setup.c queue.c syscall.c register.c
+liburing_srcs := setup.c queue.c register.c syscall.c
 
+ifeq ($(CONFIG_NOLIBC),y)
+	liburing_srcs += nolibc.c
+	override CFLAGS += -nostdlib -nodefaultlibs -ffreestanding
+	override CPPFLAGS += -nostdlib -nodefaultlibs -ffreestanding
+	override LINK_FLAGS += -nostdlib -nodefaultlibs
+endif
+
+override CPPFLAGS += -MT "$@" -MMD -MP -MF "$@.d"
 liburing_objs := $(patsubst %.c,%.ol,$(liburing_srcs))
 liburing_sobjs := $(patsubst %.c,%.os,$(liburing_srcs))
-
-$(liburing_objs) $(liburing_sobjs): include/liburing/io_uring.h
 
 %.os: %.c
 	$(QUIET_CC)$(CC) $(CPPFLAGS) $(SO_CFLAGS) -c -o $@ $<
 
 %.ol: %.c
 	$(QUIET_CC)$(CC) $(CPPFLAGS) $(L_CFLAGS) -c -o $@ $<
+
+# Include compiler generated dependency files.
+-include $(liburing_objs:%=%.d)
+-include $(liburing_sobjs:%=%.d)
 
 AR ?= ar
 RANLIB ?= ranlib
@@ -68,9 +80,11 @@
 	ln -sf $(relativelibdir)$(libname) $(libdevdir)/liburing.so
 endif
 
-$(liburing_objs): include/liburing.h
-
 clean:
 	@rm -f $(all_targets) $(liburing_objs) $(liburing_sobjs) $(soname).new
-	@rm -f *.so* *.a *.o
+	@rm -f *.so* *.a *.o *.d
 	@rm -f include/liburing/compat.h
+
+	@# When cleaning, we don't include ../config-host.mak,
+	@# so the nolibc objects are always skipped, clean them up!
+	@rm -f nolibc.ol nolibc.os

=== test/Makefile ===
prefix ?= /usr
datadir ?= $(prefix)/share

INSTALL=install

ifneq ($(MAKECMDGOALS),clean)
include ../config-host.mak
endif

CPPFLAGS ?=

override CPPFLAGS += \
	-D_GNU_SOURCE \
	-D__SANE_USERSPACE_TYPES__ \
	-I../src/include/ \
	-include ../config-host.h

CFLAGS ?= -g -O3 -Wall -Wextra
XCFLAGS = -Wno-unused-parameter -Wno-sign-compare

ifdef CONFIG_HAVE_STRINGOP_OVERFLOW
	XCFLAGS += -Wstringop-overflow=0
endif

ifdef CONFIG_HAVE_ARRAY_BOUNDS
	XCFLAGS += -Warray-bounds=0
endif

CXXFLAGS ?= $(CFLAGS)
override CFLAGS += $(XCFLAGS) -DLIBURING_BUILD_TEST
override CXXFLAGS += $(XCFLAGS) -std=c++11 -DLIBURING_BUILD_TEST

LDFLAGS ?=
override LDFLAGS += -L../src/ -luring -lpthread

# Please keep this list sorted alphabetically.
test_srcs := \
	232c93d07b74.c \
	35fa71a030ca.c \
	500f9fbadef8.c \
	7ad0e4b2f83c.c \
	8a9973408177.c \
	917257daa0fe.c \
	a0908ae19763.c \
	a4c0b3decb33.c \
	accept.c \
	accept-link.c \
	accept-reuse.c \
	accept-test.c \
	across-fork.c \
	b19062a56726.c \
	b5837bd5311d.c \
	buf-ring.c \
	ce593a6c480a.c \
	close-opath.c \
	connect.c \
	cq-full.c \
	cq-overflow.c \
	cq-peek-batch.c \
	cq-ready.c \
	cq-size.c \
	d4ae271dfaae.c \
	d77a67ed5f27.c \
	defer.c \
	defer-taskrun.c \
	double-poll-crash.c \
	drop-submit.c \
	eeed8b54e0df.c \
	empty-eownerdead.c \
	eventfd.c \
	eventfd-disable.c \
	eventfd-reg.c \
	eventfd-ring.c \
	exec-target.c \
	exit-no-cleanup.c \
	fadvise.c \
	fallocate.c \
	fc2a85cb02ef.c \
	fd-pass.c \
	file-register.c \
	files-exit-hang-poll.c \
	files-exit-hang-timeout.c \
	file-update.c \
	file-verify.c \
	fixed-buf-iter.c \
	fixed-link.c \
	fixed-reuse.c \
	fpos.c \
	fsync.c \
	hardlink.c \
	io-cancel.c \
	iopoll.c \
	iopoll-leak.c \
	io_uring_enter.c \
	io_uring_passthrough.c \
	io_uring_register.c \
	io_uring_setup.c \
	lfs-openat.c \
	lfs-openat-write.c \
	link.c \
	link_drain.c \
	link-timeout.c \
	madvise.c \
	mkdir.c \
	msg-ring.c \
	multicqes_drain.c \
	nolibc.c \
	nop-all-sizes.c \
	nop.c \
	openat2.c \
	open-close.c \
	open-direct-link.c \
	open-direct-pick.c \
	personality.c \
	pipe-eof.c \
	pipe-reuse.c \
	poll.c \
	poll-cancel.c \
	poll-cancel-all.c \
	poll-cancel-ton.c \
	poll-link.c \
	poll-many.c \
	poll-mshot-update.c \
	poll-mshot-overflow.c \
	poll-ring.c \
	poll-v-poll.c \
	pollfree.c \
	probe.c \
	read-before-exit.c \
	read-write.c \
	recv-msgall.c \
	recv-msgall-stream.c \
	recv-multishot.c \
	register-restrictions.c \
	rename.c \
	ringbuf-read.c \
	ring-leak2.c \
	ring-leak.c \
	rsrc_tags.c \
	rw_merge_test.c \
	self.c \
	sendmsg_fs_cve.c \
	send_recv.c \
	send_recvmsg.c \
	shared-wq.c \
	short-read.c \
	shutdown.c \
	sigfd-deadlock.c \
	skip-cqe.c \
	socket.c \
	socket-rw.c \
	socket-rw-eagain.c \
	socket-rw-offset.c \
	splice.c \
	sq-full.c \
	sq-full-cpp.cc \
	sqpoll-cancel-hang.c \
	sqpoll-disable-exit.c \
	sq-poll-dup.c \
	sqpoll-exit-hang.c \
	sq-poll-kthread.c \
	sq-poll-share.c \
	sqpoll-sleep.c \
	sq-space_left.c \
	stdout.c \
	submit-and-wait.c \
	submit-link-fail.c \
	submit-reuse.c \
	sync-cancel.c \
	symlink.c \
	teardowns.c \
	thread-exit.c \
	timeout.c \
	timeout-new.c \
	timeout-overflow.c \
	tty-write-dpoll.c \
	unlink.c \
	wakeup-hang.c \
	xattr.c \
	skip-cqe.c \
	single-issuer.c \
	send-zerocopy.c \
	# EOL

all_targets :=
include ../Makefile.quiet

ifdef CONFIG_HAVE_STATX
	test_srcs += statx.c
else ifdef CONFIG_HAVE_GLIBC_STATX
	test_srcs += statx.c
endif
all_targets += statx.t

ifdef CONFIG_HAVE_CXX
	test_srcs += sq-full-cpp.cc
endif
all_targets += sq-full-cpp.t


test_targets := $(patsubst %.c,%,$(test_srcs))
test_targets := $(patsubst %.cc,%,$(test_targets))
run_test_targets := $(patsubst %,%.run_test,$(test_targets))
test_targets := $(patsubst %,%.t,$(test_targets))
all_targets += $(test_targets)
helpers = helpers.o

all: $(test_targets)

helpers.o: helpers.c
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<

%.t: %.c $(helpers) helpers.h ../src/liburing.a
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $< $(helpers) $(LDFLAGS)

%.t: %.cc $(helpers) helpers.h ../src/liburing.a
	$(QUIET_CXX)$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $< $(helpers) $(LDFLAGS)


install: $(test_targets) runtests.sh runtests-loop.sh
	$(INSTALL) -D -d -m 755 $(datadir)/liburing-test/
	$(INSTALL) -D -m 755 $(test_targets) $(datadir)/liburing-test/
	$(INSTALL) -D -m 755 runtests.sh  $(datadir)/liburing-test/
	$(INSTALL) -D -m 755 runtests-loop.sh  $(datadir)/liburing-test/

clean:
	@rm -f $(all_targets) helpers.o output/*
	@rm -rf output/

runtests: all
	@./runtests.sh $(test_targets)

runtests-loop: all
	@./runtests-loop.sh $(test_targets)

%.run_test: %.t
	@./runtests-quiet.sh $<

runtests-parallel: $(run_test_targets)
	@echo "All tests passed"

.PHONY: all install clean runtests runtests-loop runtests-parallel

=== debian/changelog ===
liburing (2.3-3) unstable; urgency=medium

  * Switch to Standards-Version 4.6.2 (no changes needed).
  * Do not trim debian/changelog.
  * Update copyright years.
  * Make globs in debhelper fragment files more specific.
  * Switch from hardening=+bindnow to hardening=+all.
  * Update debian/patches metadata.

 -- Guillem Jover <guillem@debian.org>  Wed, 18 Jan 2023 03:15:54 +0100

liburing (2.3-2) unstable; urgency=medium

  * Artificially bump symbol versions to 2.3 for functions involved in a
    forward compatibility ABI break, for objects built against the new
    library and run-time linked against the old one, until upstream decides
    how to fix/improve this. Closes: #1023654

 -- Guillem Jover <guillem@debian.org>  Mon, 14 Nov 2022 00:15:08 +0100

liburing (2.3-1) unstable; urgency=medium

  * New upstream release.
    - Remove 0001-Fix-typos.patch, merged upstream.
    - Remove 0002-Fix-typos.patch, ditto.
    - Remove 0003-man-Add-missing-section-numbers.patch, ditto.
    - Remove 0004-man-Lowercase-man-page-name-in-title-header.patch, ditto.
    - Remove tests-skip.patch, no longer needed.
  * Remove lintian-override false-positive, fixed in lintian.
  * Add patch fixing typos in man pages.

 -- Guillem Jover <guillem@debian.org>  Sat, 05 Nov 2022 00:14:14 +0100

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,11 @@
 Vcs-Browser: https://git.hadrons.org/cgit/debian/pkgs/liburing.git
 Vcs-Git: https://git.hadrons.org/git/debian/pkgs/liburing.git
 Homepage: https://github.com/axboe/liburing
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
+ debhelper (>= 13.10),
  procps <!nocheck>,
 
 Package: liburing2

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow future=+lfs
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all future=+lfs
 export DEB_CFLAGS_MAINT_PREPEND = -Wall
 
 DPKG_EXPORT_BUILDTOOLS = 1
@@ -37,3 +37,6 @@
 # skipped either.
 override_dh_auto_test:
 	dh_auto_test -- runtests || true
+
+override_dh_installchangelogs:
+	dh_installchangelogs --no-trim

=== debian/tests/control ===
Tests: test-build
Restrictions: flaky skippable
Depends:
 build-essential,
 pkg-config,
 liburing-dev,

Tests: test-unit
Restrictions: flaky rw-build-tree
Depends:
 build-essential,

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
https://brick.kernel.dk/snaps/ liburing-([\d\.]+)\.tar\.[gx]z debian uupdate

## liburing 2.4

=== test/Makefile ===
--- 
+++ 
@@ -13,7 +13,8 @@
 	-D_GNU_SOURCE \
 	-D__SANE_USERSPACE_TYPES__ \
 	-I../src/include/ \
-	-include ../config-host.h
+	-include ../config-host.h \
+	-D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
 
 CFLAGS ?= -g -O3 -Wall -Wextra
 XCFLAGS = -Wno-unused-parameter -Wno-sign-compare
@@ -54,6 +55,7 @@
 	ce593a6c480a.c \
 	close-opath.c \
 	connect.c \
+	connect-rep.c \
 	cq-full.c \
 	cq-overflow.c \
 	cq-peek-batch.c \
@@ -67,10 +69,12 @@
 	drop-submit.c \
 	eeed8b54e0df.c \
 	empty-eownerdead.c \
+	eploop.c \
 	eventfd.c \
 	eventfd-disable.c \
 	eventfd-reg.c \
 	eventfd-ring.c \
+	evloop.c \
 	exec-target.c \
 	exit-no-cleanup.c \
 	fadvise.c \
@@ -86,11 +90,13 @@
 	fixed-link.c \
 	fixed-reuse.c \
 	fpos.c \
+	fsnotify.c \
 	fsync.c \
 	hardlink.c \
 	io-cancel.c \
 	iopoll.c \
 	iopoll-leak.c \
+	iopoll-overflow.c \
 	io_uring_enter.c \
 	io_uring_passthrough.c \
 	io_uring_register.c \
@@ -103,6 +109,8 @@
 	madvise.c \
 	mkdir.c \
 	msg-ring.c \
+	msg-ring-flags.c \
+	msg-ring-overflow.c \
 	multicqes_drain.c \
 	nolibc.c \
 	nop-all-sizes.c \
@@ -112,6 +120,7 @@
 	open-direct-link.c \
 	open-direct-pick.c \
 	personality.c \
+	pipe-bug.c \
 	pipe-eof.c \
 	pipe-reuse.c \
 	poll.c \
@@ -120,8 +129,10 @@
 	poll-cancel-ton.c \
 	poll-link.c \
 	poll-many.c \
+	poll-mshot-overflow.c \
 	poll-mshot-update.c \
-	poll-mshot-overflow.c \
+	poll-race.c \
+	poll-race-mshot.c \
 	poll-ring.c \
 	poll-v-poll.c \
 	pollfree.c \
@@ -131,6 +142,9 @@
 	recv-msgall.c \
 	recv-msgall-stream.c \
 	recv-multishot.c \
+	reg-hint.c \
+	reg-reg-ring.c \
+	regbuf-merge.c \
 	register-restrictions.c \
 	rename.c \
 	ringbuf-read.c \
@@ -142,10 +156,12 @@
 	sendmsg_fs_cve.c \
 	send_recv.c \
 	send_recvmsg.c \
+	send-zerocopy.c \
 	shared-wq.c \
 	short-read.c \
 	shutdown.c \
 	sigfd-deadlock.c \
+	single-issuer.c \
 	skip-cqe.c \
 	socket.c \
 	socket-rw.c \
@@ -166,20 +182,17 @@
 	submit-and-wait.c \
 	submit-link-fail.c \
 	submit-reuse.c \
+	symlink.c \
 	sync-cancel.c \
-	symlink.c \
 	teardowns.c \
 	thread-exit.c \
 	timeout.c \
 	timeout-new.c \
-	timeout-overflow.c \
 	tty-write-dpoll.c \
 	unlink.c \
+	version.c \
 	wakeup-hang.c \
 	xattr.c \
-	skip-cqe.c \
-	single-issuer.c \
-	send-zerocopy.c \
 	# EOL
 
 all_targets :=
@@ -213,8 +226,17 @@
 %.t: %.c $(helpers) helpers.h ../src/liburing.a
 	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $< $(helpers) $(LDFLAGS)
 
+#
+# Clang++ is not happy with -Wmissing-prototypes:
+#
+#   cc1plus: warning: command-line option '-Wmissing-prototypes' \
+#   is valid for C/ObjC but not for C++
+#
 %.t: %.cc $(helpers) helpers.h ../src/liburing.a
-	$(QUIET_CXX)$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $< $(helpers) $(LDFLAGS)
+	$(QUIET_CXX)$(CXX) \
+	$(patsubst -Wmissing-prototypes,,$(CPPFLAGS)) \
+	$(patsubst -Wmissing-prototypes,,$(CXXFLAGS)) \
+	-o $@ $< $(helpers) $(LDFLAGS)
 
 
 install: $(test_targets) runtests.sh runtests-loop.sh

=== debian/changelog ===
liburing (2.4-1) unstable; urgency=medium

  * New upstream release.
    - Remove 0001-man-Fix-typos.patch, merged upstream.
    - Add new patch to fix stack protection disabling.
    - Add new patch to fail the build on undefined symbols.
    - Install new liburing-ffi static and shared libraries.
    - Install new man pages.
  * Fix license information for a test file in debian/copyright.

 -- Guillem Jover <guillem@debian.org>  Tue, 13 Jun 2023 02:50:52 +0200

## liburing 2.5

=== Makefile ===
--- 
+++ 
@@ -25,7 +25,7 @@
 	@$(MAKE) -C test runtests-parallel
 
 config-host.mak: configure
-	@if [ ! -e "$@" ]; then					\
+	+@if [ ! -e "$@" ]; then				\
 	  echo "Running configure ...";				\
 	  ./configure;						\
 	else							\
@@ -45,13 +45,14 @@
 	    -e "s%@VERSION@%$(VERSION)%g" \
 	    $< >$@
 
-install: $(NAME).pc
+install: $(NAME).pc $(NAME)-ffi.pc
 	@$(MAKE) -C src install prefix=$(DESTDIR)$(prefix) \
 		includedir=$(DESTDIR)$(includedir) \
 		libdir=$(DESTDIR)$(libdir) \
 		libdevdir=$(DESTDIR)$(libdevdir) \
 		relativelibdir=$(relativelibdir)
 	$(INSTALL) -D -m 644 $(NAME).pc $(DESTDIR)$(libdevdir)/pkgconfig/$(NAME).pc
+	$(INSTALL) -D -m 644 $(NAME)-ffi.pc $(DESTDIR)$(libdevdir)/pkgconfig/$(NAME)-ffi.pc
 	$(INSTALL) -m 755 -d $(DESTDIR)$(mandir)/man2
 	$(INSTALL) -m 644 man/*.2 $(DESTDIR)$(mandir)/man2
 	$(INSTALL) -m 755 -d $(DESTDIR)$(mandir)/man3
@@ -63,7 +64,7 @@
 	@$(MAKE) -C test install prefix=$(DESTDIR)$(prefix) datadir=$(DESTDIR)$(datadir)
 
 clean:
-	@rm -f config-host.mak config-host.h cscope.out $(NAME).pc test/*.dmesg
+	@rm -f config-host.mak config-host.h cscope.out $(NAME).pc $(NAME)-ffi.pc test/*.dmesg
 	@$(MAKE) -C src clean
 	@$(MAKE) -C test clean
 	@$(MAKE) -C examples clean

=== examples/Makefile ===
--- 
+++ 
@@ -10,13 +10,18 @@
 include ../config-host.mak
 endif
 
+LDFLAGS ?=
+override LDFLAGS += -L../src/ -luring -lpthread
+
 example_srcs := \
+	io_uring-close-test.c \
 	io_uring-cp.c \
 	io_uring-test.c \
 	io_uring-udp.c \
 	link-cp.c \
 	poll-bench.c \
-	send-zerocopy.c
+	send-zerocopy.c \
+	rsrc-update-bench.c
 
 all_targets :=

=== src/Makefile ===
include ../Makefile.common

prefix ?= /usr
includedir ?= $(prefix)/include
libdir ?= $(prefix)/lib
libdevdir ?= $(prefix)/lib

LIBURING_CFLAGS ?=
CPPFLAGS ?=
override CPPFLAGS += -D_GNU_SOURCE \
	-Iinclude/ -include ../config-host.h \
	-D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
CFLAGS ?= -g -O3 -Wall -Wextra -fno-stack-protector
override CFLAGS += -Wno-unused-parameter \
	-DLIBURING_INTERNAL \
	$(LIBURING_CFLAGS)
SO_CFLAGS=-fPIC $(CFLAGS)
L_CFLAGS=$(CFLAGS)
LINK_FLAGS=-Wl,-z,defs
LINK_FLAGS+=$(LDFLAGS)
ENABLE_SHARED ?= 1

soname=liburing.so.$(VERSION_MAJOR)
libname=liburing.so.$(VERSION)
ffi_soname=liburing-ffi.so.$(VERSION_MAJOR)
ffi_libname=liburing-ffi.so.$(VERSION)

all_targets += liburing.a
all_targets += liburing-ffi.a

ifeq ($(ENABLE_SHARED),1)
all_targets += $(libname)
all_targets += $(ffi_libname)
endif

include ../Makefile.quiet

ifneq ($(MAKECMDGOALS),clean)
include ../config-host.mak
endif

all: $(all_targets)

liburing_srcs := setup.c queue.c register.c syscall.c version.c

ifeq ($(CONFIG_NOLIBC),y)
	liburing_srcs += nolibc.c
	override CFLAGS += -nostdlib -nodefaultlibs -ffreestanding -fno-builtin -fno-stack-protector
	override CPPFLAGS += -nostdlib -nodefaultlibs -ffreestanding -fno-builtin -fno-stack-protector
	override LINK_FLAGS += -nostdlib -nodefaultlibs -lgcc
endif

override CPPFLAGS += -MT "$@" -MMD -MP -MF "$@.d"
liburing_objs := $(patsubst %.c,%.ol,$(liburing_srcs))
liburing_sobjs := $(patsubst %.c,%.os,$(liburing_srcs))
liburing_ffi_objs := ffi.ol
liburing_ffi_sobjs := ffi.os

%.os: %.c
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(SO_CFLAGS) -c -o $@ $<

%.ol: %.c
	$(QUIET_CC)$(CC) $(CPPFLAGS) $(L_CFLAGS) -c -o $@ $<

# Include compiler generated dependency files.
-include $(liburing_objs:%=%.d)
-include $(liburing_sobjs:%=%.d)

AR ?= ar
RANLIB ?= ranlib
liburing.a: $(liburing_objs)
	@rm -f liburing.a
	$(QUIET_AR)$(AR) r liburing.a $^
	$(QUIET_RANLIB)$(RANLIB) liburing.a

liburing-ffi.a: $(liburing_objs) $(liburing_ffi_objs)
	@rm -f liburing-ffi.a
	$(QUIET_AR)$(AR) r liburing-ffi.a $^
	$(QUIET_RANLIB)$(RANLIB) liburing-ffi.a

$(libname): $(liburing_sobjs) liburing.map
	$(QUIET_CC)$(CC) $(SO_CFLAGS) -shared -Wl,--version-script=liburing.map -Wl,-soname=$(soname) -o $@ $(liburing_sobjs) $(LINK_FLAGS)

$(ffi_libname): $(liburing_ffi_objs) $(liburing_ffi_sobjs) $(liburing_sobjs) liburing-ffi.map
	$(QUIET_CC)$(CC) $(SO_CFLAGS) -shared -Wl,--version-script=liburing-ffi.map -Wl,-soname=$(ffi_soname) -o $@ $(liburing_sobjs) $(liburing_ffi_sobjs) $(LINK_FLAGS)

install: $(all_targets)
	install -D -m 644 include/liburing/io_uring.h $(includedir)/liburing/io_uring.h
	install -D -m 644 include/liburing.h $(includedir)/liburing.h
	install -D -m 644 include/liburing/compat.h $(includedir)/liburing/compat.h
	install -D -m 644 include/liburing/barrier.h $(includedir)/liburing/barrier.h
	install -D -m 644 include/liburing/io_uring_version.h $(includedir)/liburing/io_uring_version.h
	install -D -m 644 liburing.a $(libdevdir)/liburing.a
	install -D -m 644 liburing-ffi.a $(libdevdir)/liburing-ffi.a
ifeq ($(ENABLE_SHARED),1)
	install -D -m 755 $(libname) $(libdir)/$(libname)
	install -D -m 755 $(ffi_libname) $(libdir)/$(ffi_libname)
	ln -sf $(libname) $(libdir)/$(soname)
	ln -sf $(relativelibdir)$(libname) $(libdevdir)/liburing.so
	ln -sf $(ffi_libname) $(libdir)/$(ffi_soname)
	ln -sf $(relativelibdir)$(ffi_libname) $(libdevdir)/liburing-ffi.so
endif

clean:
	@rm -f $(all_targets) $(liburing_objs) $(liburing_sobjs) $(liburing_ffi_objs) $(liburing_ffi_sobjs) $(soname).new
	@rm -f *.so* *.a *.o *.d
	@rm -f include/liburing/compat.h
	@rm -f include/liburing/io_uring_version.h

	@# When cleaning, we don't include ../config-host.mak,
	@# so the nolibc objects are always skipped, clean them up!
	@rm -f nolibc.ol nolibc.os

=== test/Makefile ===
--- 
+++ 
@@ -56,6 +56,7 @@
 	close-opath.c \
 	connect.c \
 	connect-rep.c \
+	coredump.c \
 	cq-full.c \
 	cq-overflow.c \
 	cq-peek-batch.c \
@@ -112,6 +113,7 @@
 	msg-ring-flags.c \
 	msg-ring-overflow.c \
 	multicqes_drain.c \
+	no-mmap-inval.c \
 	nolibc.c \
 	nop-all-sizes.c \
 	nop.c \
@@ -142,6 +144,7 @@
 	recv-msgall.c \
 	recv-msgall-stream.c \
 	recv-multishot.c \
+	reg-fd-only.c \
 	reg-hint.c \
 	reg-reg-ring.c \
 	regbuf-merge.c \
@@ -153,7 +156,6 @@
 	rsrc_tags.c \
 	rw_merge_test.c \
 	self.c \
-	sendmsg_fs_cve.c \
 	send_recv.c \
 	send_recvmsg.c \
 	send-zerocopy.c \
@@ -164,6 +166,7 @@
 	single-issuer.c \
 	skip-cqe.c \
 	socket.c \
+	socket-io-cmd.c \
 	socket-rw.c \
 	socket-rw-eagain.c \
 	socket-rw-offset.c \
@@ -192,6 +195,7 @@
 	unlink.c \
 	version.c \
 	wakeup-hang.c \
+	wq-aff.c \
 	xattr.c \
 	# EOL
 
@@ -223,7 +227,9 @@
 helpers.o: helpers.c
 	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<
 
-%.t: %.c $(helpers) helpers.h ../src/liburing.a
+LIBURING := $(shell if [ -e ../src/liburing.a ]; then echo ../src/liburing.a; fi)
+
+%.t: %.c $(helpers) helpers.h $(LIBURING)
 	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $< $(helpers) $(LDFLAGS)
 
 #
@@ -232,7 +238,7 @@
 #   cc1plus: warning: command-line option '-Wmissing-prototypes' \
 #   is valid for C/ObjC but not for C++
 #
-%.t: %.cc $(helpers) helpers.h ../src/liburing.a
+%.t: %.cc $(helpers) helpers.h $(LIBURING)
 	$(QUIET_CXX)$(CXX) \
 	$(patsubst -Wmissing-prototypes,,$(CPPFLAGS)) \
 	$(patsubst -Wmissing-prototypes,,$(CXXFLAGS)) \

=== debian/changelog ===
liburing (2.5-1build1) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 18:08:15 +0200

liburing (2.5-1) unstable; urgency=medium

  * New upstream release.
    - Remove 0001-build-Disable-stack-protector-unconditionally.patch,
      merged upstream.
    - Remove 0002-build-Fail-the-build-if-we-have-undefined-symbols.patch,
      ditto.
  * Switch back to use libc (from nolibc) after the support got restored
    upstream with the new configure --use-libc option.
  * Switch autopkgtest dependency from pkg-config to pkgconf.
  * Wrap fields in debian/tests/control.
  * Fix a typo in the manual pages.

 -- Guillem Jover <guillem@debian.org>  Fri, 10 Nov 2023 02:30:36 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: liburing
 Section: libs
 Priority: optional
-Maintainer: Guillem Jover <guillem@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Guillem Jover <guillem@debian.org>
 Vcs-Browser: https://git.hadrons.org/cgit/debian/pkgs/liburing.git
 Vcs-Git: https://git.hadrons.org/git/debian/pkgs/liburing.git
 Homepage: https://github.com/axboe/liburing

=== debian/rules ===
--- 
+++ 
@@ -28,12 +28,13 @@
 	  --mandir=/usr/share/man \
 	  --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
 	  --libdevdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
+	  --use-libc \
 	  --cc=$(CC)
 
 override_dh_auto_build:
 	dh_auto_build -- $(buildflags)
 
-# XXX: The tests do not pass yet on Linux 5.13, and they are not being
+# XXX: The tests do not pass yet as of Linux 6.5, and they are not being
 # skipped either.
 override_dh_auto_test:
 	dh_auto_test -- runtests || true

## liburing 2.6

=== debian/changelog ===
liburing (2.6-1) unstable; urgency=medium

  * New upstream release.
    - Remove 0001-man-io_uring_queue_init.3-Fix-typo.patch, merged upstream.
    - Add patches from upstream git:
      0001-test-skip-test-case-if-underlying-filesystem-doesn-t.patch,
      0002-test-buf-ring-skip-on-older-kernels-that-don-t-suppo.patch
      0003-man-fix-IORING_REGISTER_RING_FDS-docs.patch
    - Clean test/core-coredump.t as it is an expected artifact.
  * Switch from future=+lfs to abi=+lfs build flags feature, and Build-Depends
    on dpkg-dev >= 1.22.0.
  * Switch to Standards-Version 4.7.0 (no changes needed).

 -- Guillem Jover <guillem@debian.org>  Sun, 05 May 2024 17:29:50 +0200

## liburing 2.8

=== examples/Makefile ===
--- 
+++ 
@@ -13,15 +13,25 @@
 LDFLAGS ?=
 override LDFLAGS += -L../src/ -luring -lpthread
 
+ifeq ($(CONFIG_USE_SANITIZER),y)
+	override CFLAGS += -fsanitize=address,undefined -fno-omit-frame-pointer -fno-optimize-sibling-calls
+	override CPPFLAGS += -fsanitize=address,undefined -fno-omit-frame-pointer -fno-optimize-sibling-calls
+	override LDFLAGS += -fsanitize=address,undefined
+endif
+
 example_srcs := \
 	io_uring-close-test.c \
 	io_uring-cp.c \
 	io_uring-test.c \
 	io_uring-udp.c \
 	link-cp.c \
+	napi-busy-poll-client.c \
+	napi-busy-poll-server.c \
 	poll-bench.c \
 	send-zerocopy.c \
-	rsrc-update-bench.c
+	rsrc-update-bench.c \
+	proxy.c \
+	kdigest.c
 
 all_targets :=
 
@@ -29,16 +39,20 @@
 ifdef CONFIG_HAVE_UCONTEXT
 	example_srcs += ucontext-cp.c
 endif
-all_targets += ucontext-cp
+all_targets += ucontext-cp helpers.o
 
 example_targets := $(patsubst %.c,%,$(patsubst %.cc,%,$(example_srcs)))
 all_targets += $(example_targets)
 
+helpers = helpers.o
 
 all: $(example_targets)
 
-%: %.c ../src/liburing.a
-	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $< $(LDFLAGS)
+helpers.o: helpers.c
+	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<
+
+%: %.c $(helpers) ../src/liburing.a
+	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $< $(helpers) $(LDFLAGS)
 
 clean:
 	@rm -f $(all_targets)

=== debian/changelog ===
liburing (2.8-1) unstable; urgency=medium

  * New upstream release.
    - Remove patches merged or pulled from upstream:
      0001-Don-t-set-_GNU_SOURCE-in-pkg-config-cflags.patch
      0001-Fix-typos.patch
      0002-Fix-typos.patch

 -- Guillem Jover <guillem@debian.org>  Sat, 26 Oct 2024 23:31:51 +0200

liburing (2.7-2) unstable; urgency=medium

  * Do not define _GNU_SOURCE in the .pc file Cflags. Closes: #1080419

 -- Guillem Jover <guillem@debian.org>  Wed, 04 Sep 2024 00:51:39 +0200

liburing (2.7-1) unstable; urgency=medium

  * New upstream release.
    - Remove patches pulled from upstream:
      0001-test-skip-test-case-if-underlying-filesystem-doesn-t.patch
      0002-test-buf-ring-skip-on-older-kernels-that-don-t-suppo.patch
      0003-man-fix-IORING_REGISTER_RING_FDS-docs.patch
  * Fix typos in code and manual pages.

 -- Guillem Jover <guillem@debian.org>  Tue, 27 Aug 2024 10:36:30 +0200
